cdac.medinfo.sdk.hl7282.baselibs.segments

## Class LDP

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.LDP

- All Implemented Interfaces:
    ISegment

      public class LDP
      extends Segment

  LDP - Location Department Segment.

  LDP segment identifies how a patient location room is being used by a certain department. Multiple departments can use the same patient location, so there can be multiple LDP segments following an LOC segment.

  Represents an HL7 LDP message segment. This segment has the following fields:

  LDP-1: Primary Key Value - LDP (PL)Required
  LDP-2: Location Department (CWE)Required
  LDP-3: Location Service (CWE)Optional
  LDP-4: Specialty Type (CWE)Optional
  LDP-5: Valid Patient Classes (CWE)Optional
  LDP-6: Active/Inactive Flag (ID)Optional
  LDP-7: Activation Date LDP (DTM)Optional
  LDP-8: Inactivation Date - LDP (DTM)Optional
  LDP-9: Inactivated Reason (ST)Optional
  LDP-10: Visiting Hours (VH)Optional
  LDP-11: Contact Phone (XTN)Optional
  LDP-12: Location Cost Center (CWE)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `LDP()` Constructs the LDP segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addLocationService(CWE objlocationService)` Add the Location Service.
    `void` | `addLocationService(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Add the Location Service.
    `void` | `addSpecialtyType(CWE objspecialtyType)` Add the Specialty Type.
    `void` | `addSpecialtyType(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Add the Specialty Type.
    `void` | `addValidPatientClasses(CWE objvalidPatientClasses)` Add the Valid Patient Classes.
    `void` | `addValidPatientClasses(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Add the Valid Patient Classes.
    `void` | `addVisitingHours(java.lang.String strStartDayRange, java.lang.String strEndDayRange, java.lang.String strStartHourRange, java.lang.String strEndHourRange)` Add the Visiting Hours.
    `void` | `addVisitingHours(VH objvisitingHours)` Add the Visiting Hours.
    `DTM` | `getActivationDateLDP()` Retrieves the Activation Date LDP.
    `ID` | `getActiveInactiveFlag()` Retrieves the Active Inactive Flag.
    `XTN` | `getContactPhone()` Retrieves the Contact Phone.
    `ST` | `getInactivatedReason()` Retrieves the Inactivated Reason.
    `DTM` | `getInactivationDateLDP()` Retrieves the Inactivation Date LDP.
    `CWE` | `getLocationCostCenter()` Retrieves the Location Cost Center.
    `CWE` | `getLocationDepartment()` Retrieves the Location Department.
    `ISingleCollection<CWE>` | `getLocationService()` Retrieves the Location Service.
    `PL` | `getPrimaryKeyValueLDP()` Retrieves the Primary Key Value LDP.
    `ISingleCollection<CWE>` | `getSpecialtyType()` Retrieves the Specialty Type.
    `ISingleCollection<CWE>` | `getValidPatientClasses()` Retrieves the Valid Patient Classes.
    `ISingleCollection<VH>` | `getVisitingHours()` Retrieves the Visiting Hours.
    `void` | `setActivationDateLDP(DTM objactivationDateLDP)` Set the Activation Date LDP.
    `void` | `setActivationDateLDP(java.lang.String strTime)` Set the Activation Date LDP.
    `void` | `setActiveInactiveFlag(ID objactiveInactiveFlag)` Set the Active Inactive Flag.
    `void` | `setActiveInactiveFlag(java.lang.String strActiveInactiveFlag)` Set the Active Inactive Flag.
    `void` | `setContactPhone(java.lang.String strTeleCommunicationUseCode, java.lang.String strTeleCommunicationEquipmentType, java.lang.String strCommuinicationAddress, java.lang.String strCountryCode, java.lang.String strAreaCityCode, java.lang.String strLocalNumber, java.lang.String strExtension, java.lang.String strAnyText, java.lang.String strExtensionPrefix, java.lang.String strSpeedDialCode, java.lang.String strUnformattedTelephoneNumber, java.lang.String strEffectiveStartDate, java.lang.String strExpirationDate, CWE objExpirationReason, CWE objProtectionCode, EI objSharedTelecommunicationIdentifier, java.lang.String strPreferenceOrder)` Set the Contact Phone.
    `void` | `setContactPhone(XTN objcontactPhone)` Set the Contact Phone.
    `void` | `setInactivatedReason(ST objinactivatedReason)` Set the Inactivated Reason.
    `void` | `setInactivatedReason(java.lang.String strInactivatedReason)` Set the Inactivated Reason.
    `void` | `setInactivationDateLDP(DTM objinactivationDateLDP)` Set the Inactivation Date LDP.
    `void` | `setInactivationDateLDP(java.lang.String strTime)` Set the Inactivation Date LDP.
    `void` | `setLocationCostCenter(CWE objlocationCostCenter)` Set the Location Cost Center.
    `void` | `setLocationCostCenter(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Location Cost Center.
    `void` | `setLocationDepartment(CWE objlocationDepartment)` Set the Location Department.
    `void` | `setLocationDepartment(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Location Department.
    `void` | `setLocationService(ISingleCollection<CWE> objlocationServiceList)` Set the Location Service.
    `void` | `setPrimaryKeyValueLDP(HD objPointOfCare, HD objRoom, HD objBed, HD objFacility, java.lang.String strLocationStatus, java.lang.String strPersonLocationType, HD objBuilding, HD objFloor, java.lang.String strLocationDescription, EI objComprehensiveLocationIdentifier, HD objAssigningAuthorityForLocation)` Set the Primary Key Value LDP.
    `void` | `setPrimaryKeyValueLDP(PL objprimaryKeyValueLDP)` Set the Primary Key Value LDP.
    `void` | `setSpecialtyType(ISingleCollection<CWE> objspecialtyTypeList)` Set the Specialty Type.
    `void` | `setValidPatientClasses(ISingleCollection<CWE> objvalidPatientClassesList)` Set the Valid Patient Classes.
    `void` | `setVisitingHours(ISingleCollection<VH> objvisitingHoursList)` Set the Visiting Hours.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LDP

          public LDP()

      Constructs the LDP segment.

  - ### Method Detail

    - #### getActivationDateLDP

          public DTM getActivationDateLDP()

      Retrieves the Activation Date LDP. This field contains the date and time when the location became active or "in service" for a department.
      Returns:
        DTM - activationDateLDP

    - #### getActiveInactiveFlag

          public ID getActiveInactiveFlag()

      Retrieves the Active Inactive Flag. This indicates whether the entry for this location is currently an active, that is, valid, usable entry or not.
      Returns:
        ID - activeInactiveFlag

    - #### getContactPhone

          public XTN getContactPhone()

      Retrieves the Contact Phone. This field contains the phone number to use to contact facility personnel about the patient location, in case of inquiries about the location.
      Returns:
        XTN - contactPhone

    - #### getInactivatedReason

          public ST getInactivatedReason()

      Retrieves the Inactivated Reason. This field contains the reason the location is put out of service.
      Returns:
        ST - inactivatedReason

    - #### getInactivationDateLDP

          public DTM getInactivationDateLDP()

      Retrieves the Inactivation Date LDP. This field contains the date when the location became inactive or "out of service" for this department.
      Returns:
        DTM - inactivationDateLDP

    - #### getLocationCostCenter

          public CWE getLocationCostCenter()

      Retrieves the Location Cost Center. This field contains the cost center to which this location belongs.
      Returns:
        CWE - locationCostCenter

    - #### getLocationDepartment

          public CWE getLocationDepartment()

      Retrieves the Location Department. This field contains the institution's department to which this location belongs, or its cost center.
      Returns:
        CWE - locationDepartment

    - #### getLocationService

          public ISingleCollection<CWE> getLocationService()

      Retrieves the Location Service. This field contains the hospital or ancillary service with which this location is associated.
      Returns:
        ISingleCollection - locationService

    - #### getPrimaryKeyValueLDP

          public PL getPrimaryKeyValueLDP()

      Retrieves the Primary Key Value LDP. This field contains the institution's identification code for the location.
      Returns:
        PL - primaryKeyValueLDP

    - #### getSpecialtyType

          public ISingleCollection<CWE> getSpecialtyType()

      Retrieves the Specialty Type.
      Returns:
        ISingleCollection - specialtyType

    - #### getValidPatientClasses

          public ISingleCollection<CWE> getValidPatientClasses()

      Retrieves the Valid Patient Classes. This field contains the patient types that are allowed to be assigned to this bed.
      Returns:
        ISingleCollection - validPatientClasses

    - #### getVisitingHours

          public ISingleCollection<VH> getVisitingHours()

      Retrieves the Visiting Hours. This field contains the hours when this location is open for visiting.
      Returns:
        ISingleCollection - visitingHours

    - #### setPrimaryKeyValueLDP

          public void setPrimaryKeyValueLDP(HD objPointOfCare,
                                   HD objRoom,
                                   HD objBed,
                                   HD objFacility,
                                   java.lang.String strLocationStatus,
                                   java.lang.String strPersonLocationType,
                                   HD objBuilding,
                                   HD objFloor,
                                   java.lang.String strLocationDescription,
                                   EI objComprehensiveLocationIdentifier,
                                   HD objAssigningAuthorityForLocation)

      Set the Primary Key Value LDP. This field contains the institution's identification code for the location.
      Parameters:
        `objPointOfCare` - Specifies the code for the point where patient care is administered.
        `objRoom` - Specifies the code for the patient's room.
        `objBed` - Specifies the code for the patient's bed.
        `objFacility` - Specifies to site interpretation but generally describes the highest level physical designation of an institution, medical center or enterprise.
        `strLocationStatus` - Specifies the code for the status or availability of the location.
        `strPersonLocationType` - Specifies the categorization of the person's location defined by facility, building, floor, point of care, room or bed.
        `objBuilding` - Specifies code for the building where the person is located.
        `objFloor` - Specifies the code for the floor where the person is located.
        `strLocationDescription` - Specifies describes the location in free text.
        `objComprehensiveLocationIdentifier` - Specifies represents the physical location as a whole without regard for the individual components.
        `objAssigningAuthorityForLocation` - Specifies the entity that creates the data for the individual physical location components.

    - #### setPrimaryKeyValueLDP

          public void setPrimaryKeyValueLDP(PL objprimaryKeyValueLDP)

      Set the Primary Key Value LDP. This field contains the institution's identification code for the location.
      Parameters:
        `objprimaryKeyValueLDP` - Object of Primary Key Value LDP.

    - #### setLocationDepartment

          public void setLocationDepartment(java.lang.String strIdentifier,
                                   java.lang.String strText,
                                   java.lang.String strNameOfCodingSystem,
                                   java.lang.String strAlternateIdentifier,
                                   java.lang.String strAlternateText,
                                   java.lang.String strNameOfAlternateCodingSystem,
                                   java.lang.String strCodingSystemVersionID,
                                   java.lang.String strAlternateCodingSystemVersionId,
                                   java.lang.String strOriginalText,
                                   java.lang.String strSecondAlternateIdentifier,
                                   java.lang.String strSecondAlternateText,
                                   java.lang.String strNameofSecondAlternateCodingSystem,
                                   java.lang.String strSecondAlternateCodingSystemVersionID,
                                   java.lang.String strCodingSystemOID,
                                   java.lang.String strValueSetOID,
                                   java.lang.String strValueSetVersionID,
                                   java.lang.String strAlternateCodingSystemOID,
                                   java.lang.String strAlternateValueSetOID,
                                   java.lang.String strAlternateValueSetVersionID,
                                   java.lang.String strSecondAlternateCodingSystemOID,
                                   java.lang.String strSecondAlternateValueSetOID,
                                   java.lang.String strSecondAlternateValueSetVersionID)

      Set the Location Department. This field contains the institution's department to which this location belongs, or its cost center.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setLocationDepartment

          public void setLocationDepartment(CWE objlocationDepartment)

      Set the Location Department. This field contains the institution's department to which this location belongs, or its cost center.
      Parameters:
        `objlocationDepartment` - Object of Location Department.

    - #### addLocationService

          public void addLocationService(java.lang.String strIdentifier,
                                java.lang.String strText,
                                java.lang.String strNameOfCodingSystem,
                                java.lang.String strAlternateIdentifier,
                                java.lang.String strAlternateText,
                                java.lang.String strNameOfAlternateCodingSystem,
                                java.lang.String strCodingSystemVersionID,
                                java.lang.String strAlternateCodingSystemVersionId,
                                java.lang.String strOriginalText,
                                java.lang.String strSecondAlternateIdentifier,
                                java.lang.String strSecondAlternateText,
                                java.lang.String strNameofSecondAlternateCodingSystem,
                                java.lang.String strSecondAlternateCodingSystemVersionID,
                                java.lang.String strCodingSystemOID,
                                java.lang.String strValueSetOID,
                                java.lang.String strValueSetVersionID,
                                java.lang.String strAlternateCodingSystemOID,
                                java.lang.String strAlternateValueSetOID,
                                java.lang.String strAlternateValueSetVersionID,
                                java.lang.String strSecondAlternateCodingSystemOID,
                                java.lang.String strSecondAlternateValueSetOID,
                                java.lang.String strSecondAlternateValueSetVersionID)

      Add the Location Service. This field contains the hospital or ancillary service with which this location is associated.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### addLocationService

          public void addLocationService(CWE objlocationService)

      Add the Location Service. This field contains the hospital or ancillary service with which this location is associated.
      Parameters:
        `objlocationService` - Object of Location Service.

    - #### setLocationService

          public void setLocationService(ISingleCollection<CWE> objlocationServiceList)

      Set the Location Service. This field contains the hospital or ancillary service with which this location is associated.
      Parameters:
        `objlocationServiceList` - List of Location Service.

    - #### addSpecialtyType

          public void addSpecialtyType(java.lang.String strIdentifier,
                              java.lang.String strText,
                              java.lang.String strNameOfCodingSystem,
                              java.lang.String strAlternateIdentifier,
                              java.lang.String strAlternateText,
                              java.lang.String strNameOfAlternateCodingSystem,
                              java.lang.String strCodingSystemVersionID,
                              java.lang.String strAlternateCodingSystemVersionId,
                              java.lang.String strOriginalText,
                              java.lang.String strSecondAlternateIdentifier,
                              java.lang.String strSecondAlternateText,
                              java.lang.String strNameofSecondAlternateCodingSystem,
                              java.lang.String strSecondAlternateCodingSystemVersionID,
                              java.lang.String strCodingSystemOID,
                              java.lang.String strValueSetOID,
                              java.lang.String strValueSetVersionID,
                              java.lang.String strAlternateCodingSystemOID,
                              java.lang.String strAlternateValueSetOID,
                              java.lang.String strAlternateValueSetVersionID,
                              java.lang.String strSecondAlternateCodingSystemOID,
                              java.lang.String strSecondAlternateValueSetOID,
                              java.lang.String strSecondAlternateValueSetVersionID)

      Add the Specialty Type.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### addSpecialtyType

          public void addSpecialtyType(CWE objspecialtyType)

      Add the Specialty Type.
      Parameters:
        `objspecialtyType` - Object of Specialty Type.

    - #### setSpecialtyType

          public void setSpecialtyType(ISingleCollection<CWE> objspecialtyTypeList)

      Set the Specialty Type.
      Parameters:
        `objspecialtyTypeList` - List of Specialty Type.

    - #### addValidPatientClasses

          public void addValidPatientClasses(java.lang.String strIdentifier,
                                    java.lang.String strText,
                                    java.lang.String strNameOfCodingSystem,
                                    java.lang.String strAlternateIdentifier,
                                    java.lang.String strAlternateText,
                                    java.lang.String strNameOfAlternateCodingSystem,
                                    java.lang.String strCodingSystemVersionID,
                                    java.lang.String strAlternateCodingSystemVersionId,
                                    java.lang.String strOriginalText,
                                    java.lang.String strSecondAlternateIdentifier,
                                    java.lang.String strSecondAlternateText,
                                    java.lang.String strNameofSecondAlternateCodingSystem,
                                    java.lang.String strSecondAlternateCodingSystemVersionID,
                                    java.lang.String strCodingSystemOID,
                                    java.lang.String strValueSetOID,
                                    java.lang.String strValueSetVersionID,
                                    java.lang.String strAlternateCodingSystemOID,
                                    java.lang.String strAlternateValueSetOID,
                                    java.lang.String strAlternateValueSetVersionID,
                                    java.lang.String strSecondAlternateCodingSystemOID,
                                    java.lang.String strSecondAlternateValueSetOID,
                                    java.lang.String strSecondAlternateValueSetVersionID)

      Add the Valid Patient Classes. This field contains the patient types that are allowed to be assigned to this bed.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### addValidPatientClasses

          public void addValidPatientClasses(CWE objvalidPatientClasses)

      Add the Valid Patient Classes. This field contains the patient types that are allowed to be assigned to this bed.
      Parameters:
        `objvalidPatientClasses` - Object of Valid Patient Classes.

    - #### setValidPatientClasses

          public void setValidPatientClasses(ISingleCollection<CWE> objvalidPatientClassesList)

      Set the Valid Patient Classes. This field contains the patient types that are allowed to be assigned to this bed.
      Parameters:
        `objvalidPatientClassesList` - List of Valid Patient Classes.

    - #### setActiveInactiveFlag

          public void setActiveInactiveFlag(java.lang.String strActiveInactiveFlag)

      Set the Active Inactive Flag. This indicates whether the entry for this location is currently an active, that is, valid, usable entry or not.
      Parameters:
        `strActiveInactiveFlag` - String to beb passed as Active/Inactive Flag

    - #### setActiveInactiveFlag

          public void setActiveInactiveFlag(ID objactiveInactiveFlag)

      Set the Active Inactive Flag. This indicates whether the entry for this location is currently an active, that is, valid, usable entry or not.
      Parameters:
        `objactiveInactiveFlag` - Object of Active Inactive Flag.

    - #### setActivationDateLDP

          public void setActivationDateLDP(java.lang.String strTime)

      Set the Activation Date LDP. This field contains the date and time when the location became active or "in service" for a department.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setActivationDateLDP

          public void setActivationDateLDP(DTM objactivationDateLDP)

      Set the Activation Date LDP. This field contains the date and time when the location became active or "in service" for a department.
      Parameters:
        `objactivationDateLDP` - Object of Activation Date LDP.

    - #### setInactivationDateLDP

          public void setInactivationDateLDP(java.lang.String strTime)

      Set the Inactivation Date LDP. This field contains the date when the location became inactive or "out of service" for this department.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setInactivationDateLDP

          public void setInactivationDateLDP(DTM objinactivationDateLDP)

      Set the Inactivation Date LDP. This field contains the date when the location became inactive or "out of service" for this department.
      Parameters:
        `objinactivationDateLDP` - Object of Inactivation Date LDP.

    - #### setInactivatedReason

          public void setInactivatedReason(java.lang.String strInactivatedReason)

      Set the Inactivated Reason. This field contains the reason the location is put out of service.
      Parameters:
        `strInactivatedReason` - String to be passed as Inactivated Reason

    - #### setInactivatedReason

          public void setInactivatedReason(ST objinactivatedReason)

      Set the Inactivated Reason. This field contains the reason the location is put out of service.
      Parameters:
        `objinactivatedReason` - Object of Inactivated Reason.

    - #### addVisitingHours

          public void addVisitingHours(java.lang.String strStartDayRange,
                              java.lang.String strEndDayRange,
                              java.lang.String strStartHourRange,
                              java.lang.String strEndHourRange)

      Add the Visiting Hours. This field contains the hours when this location is open for visiting.
      Parameters:
        `strStartDayRange` - Starting day of visiting hours range.
        `strEndDayRange` - Ending day of visiting hours range.
        `strStartHourRange` - Starting hour on starting day of visiting hours range.
        `strEndHourRange` - Ending hour on ending day of visiting hours range

    - #### addVisitingHours

          public void addVisitingHours(VH objvisitingHours)

      Add the Visiting Hours. This field contains the hours when this location is open for visiting.
      Parameters:
        `objvisitingHours` - Object of Visiting Hours.

    - #### setVisitingHours

          public void setVisitingHours(ISingleCollection<VH> objvisitingHoursList)

      Set the Visiting Hours. This field contains the hours when this location is open for visiting.
      Parameters:
        `objvisitingHoursList` - List of Visiting Hours.

    - #### setContactPhone

          public void setContactPhone(java.lang.String strTeleCommunicationUseCode,
                             java.lang.String strTeleCommunicationEquipmentType,
                             java.lang.String strCommuinicationAddress,
                             java.lang.String strCountryCode,
                             java.lang.String strAreaCityCode,
                             java.lang.String strLocalNumber,
                             java.lang.String strExtension,
                             java.lang.String strAnyText,
                             java.lang.String strExtensionPrefix,
                             java.lang.String strSpeedDialCode,
                             java.lang.String strUnformattedTelephoneNumber,
                             java.lang.String strEffectiveStartDate,
                             java.lang.String strExpirationDate,
                             CWE objExpirationReason,
                             CWE objProtectionCode,
                             EI objSharedTelecommunicationIdentifier,
                             java.lang.String strPreferenceOrder)

      Set the Contact Phone. This field contains the phone number to use to contact facility personnel about the patient location, in case of inquiries about the location.
      Parameters:
        `strTeleCommunicationUseCode` - Specifies a code that represents a specific use of a telecommunication number. Suggested values are PRN,ORN,WPN,VHN,ASN,EMR,NET,BPN [Refer table 0201.]
        `strTeleCommunicationEquipmentType` - Specifies a code that represents the type of telecommunication equipment. Suggested values are PH,FX,MD,CP,BP,Internet,X.400,TDD,TTY [Refer table 0202.]
        `strCommuinicationAddress` - Specifies Email address.
        `strCountryCode` - Specifies the Country code.
        `strAreaCityCode` - Specifies the area /City Code.
        `strLocalNumber` - Specifies an Local Number.
        `strExtension` - Specifies an Extension.
        `strAnyText` - Contains comments with respect to the telephone number.
        `strExtensionPrefix` - Specifies the characters established within a company's internal telephone system network used as a prefix to the Extension component for internal dialing.
        `strSpeedDialCode` - Specifies The characters established within a company's internal telephone system used in place of the (external) telephone number.
        `strUnformattedTelephoneNumber` - Specifies an expression of the telephone number as an unparsible string.
        `strEffectiveStartDate` - Specifies start date.
        `strExpirationDate` - Specifies expiration date.
        `objExpirationReason` - Specifies reason why this contact is marked as ended.
        `objProtectionCode` - Specifies reason why this information is sensitive or protected.
        `objSharedTelecommunicationIdentifier` - Specifies a unique phone number phone telephone number or email-id.
        `strPreferenceOrder` - Specifies the preference order for an entity..

    - #### setContactPhone

          public void setContactPhone(XTN objcontactPhone)

      Set the Contact Phone. This field contains the phone number to use to contact facility personnel about the patient location, in case of inquiries about the location.
      Parameters:
        `objcontactPhone` - Object of Contact Phone.

    - #### setLocationCostCenter

          public void setLocationCostCenter(java.lang.String strIdentifier,
                                   java.lang.String strText,
                                   java.lang.String strNameOfCodingSystem,
                                   java.lang.String strAlternateIdentifier,
                                   java.lang.String strAlternateText,
                                   java.lang.String strNameOfAlternateCodingSystem,
                                   java.lang.String strCodingSystemVersionID,
                                   java.lang.String strAlternateCodingSystemVersionId,
                                   java.lang.String strOriginalText,
                                   java.lang.String strSecondAlternateIdentifier,
                                   java.lang.String strSecondAlternateText,
                                   java.lang.String strNameofSecondAlternateCodingSystem,
                                   java.lang.String strSecondAlternateCodingSystemVersionID,
                                   java.lang.String strCodingSystemOID,
                                   java.lang.String strValueSetOID,
                                   java.lang.String strValueSetVersionID,
                                   java.lang.String strAlternateCodingSystemOID,
                                   java.lang.String strAlternateValueSetOID,
                                   java.lang.String strAlternateValueSetVersionID,
                                   java.lang.String strSecondAlternateCodingSystemOID,
                                   java.lang.String strSecondAlternateValueSetOID,
                                   java.lang.String strSecondAlternateValueSetVersionID)

      Set the Location Cost Center. This field contains the cost center to which this location belongs.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setLocationCostCenter

          public void setLocationCostCenter(CWE objlocationCostCenter)

      Set the Location Cost Center. This field contains the cost center to which this location belongs.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation checks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Throws when Segment Validation fails